<?php
header("Access-Control-Allow-Origin: *"); // Permite requisições de qualquer origem
header("Access-Control-Allow-Methods: GET, POST, OPTIONS"); // Métodos permitidos
header("Access-Control-Allow-Headers: Content-Type, Authorization"); // Cabeçalhos permitidos
header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
    http_response_code(204);
    exit();
}

try {
    // Conexão com o banco de dados
    $db = new PDO('pgsql:host=162.240.148.136;port=5432;dbname=wwsisp_postgres;', 'postgres', 'R312@dm1nj3q');

    // Consulta para obter os dados dos lotes
    $query = $db->query("SELECT id, nome, lote, situacao, area_2, frente, ST_AsGeoJSON(geom) AS geometry FROM golden");
    $lotes = [];

    while ($row = $query->fetch(PDO::FETCH_ASSOC)) {
        $lotes[] = [
            "type" => "Feature",
            "geometry" => json_decode($row['geometry']),
            "properties" => [
                "id" => $row['id'],
                "nome" => $row['nome'],
                "lote" => $row['lote'],
                "situacao" => $row['situacao'],
                "area_2" => $row['area_2'],
                "frente" => $row['frente']
            ]
        ];
    }

    echo json_encode([
        "type" => "FeatureCollection",
        "features" => $lotes
    ]);
} catch (PDOException $e) {
    echo json_encode(["error" => "Erro na conexão com o banco ou na consulta"]);
}
?>
