<?php
use Adianti\Control\TPage;
use Adianti\Widget\Template\THtmlRenderer;

class MapaPage extends TPage
{
    public function __construct()
    {
        parent::__construct();

        try {
            // Carregar o HTML do mapa
            $html = new THtmlRenderer('app/resources/mapa.html');
            parent::add($html);
        } catch (Exception $e) {
            // Logar qualquer erro
            $this->logError($e->getMessage());
        }
    }

    /**
     * Função para registrar erros em um arquivo de log.
     * 
     * @param string $message Mensagem de erro a ser registrada.
     */
    private function logError($message)
    {
        // Definir o caminho do arquivo de log
        $logFile = __DIR__ . '/../app/logs/adianti_map.log';

        // Verificar se o diretório é gravável
        $logDir = dirname($logFile);
        if (!is_dir($logDir)) {
            mkdir($logDir, 0777, true); // Criar diretório se não existir
        }

        if (!is_writable($logDir)) {
            error_log("Diretório não tem permissão de escrita: " . $logDir);
            return;
        }

        // Escrever a mensagem de erro no arquivo de log
        $logMessage = date('Y-m-d H:i:s') . ' - ' . $message . PHP_EOL;
        file_put_contents($logFile, $logMessage, FILE_APPEND);
    }
}
